SystemOrganization addCategory: #'Pier-Wysiwyg'!

PRViewRenderer subclass: #PRWysiwygHtmlRenderer
	instanceVariableNames: 'wikiRenderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygHtmlRenderer methodsFor: 'constants' stamp: 'NickAger 7/11/2011 17:35'!
nonEditable
	^ 'yui-noedit pierNonEditable'
	
! !

!PRWysiwygHtmlRenderer methodsFor: 'visiting-document' stamp: 'NickAger 7/12/2011 08:41'!
visitHeader: anObject
	"override as in the editor we don't care about the named anchor"
	html heading level: anObject level; with: [
		self visitDocumentGroup: anObject ]! !

!PRWysiwygHtmlRenderer methodsFor: 'visiting-document' stamp: 'NickAger 7/18/2011 12:01'!
visitInternalLink: aLink
	aLink isEmbedded 
		ifTrue: [
			html span
				class: 'pierEmbeddedLink';
				class: self nonEditable;
					with: [
						html text: (PRWikiWriter write: aLink) ] ]	
		ifFalse: [
			super visitInternalLink: aLink ]

! !

!PRWysiwygHtmlRenderer methodsFor: 'visiting-document' stamp: 'NickAger 7/18/2011 12:01'!
visitValueLink: aLink 
	html span
		class: 'pierValueLink';
		class: self nonEditable;
			with: [
				html text: (PRWikiWriter write: aLink) ]
! !

!PRWysiwygHtmlRenderer methodsFor: 'visiting-document' stamp: 'NickAger 7/18/2011 12:00'!
visitVerbatim: aVerbatim
	html span
		class: 'pierVerbatim';
		class: self nonEditable;
			with: [
				html text: (PRWikiWriter write: aVerbatim) ] ! !

WAFileLibrary subclass: #PRWysiwygFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygFileLibrary methodsFor: 'uploaded' stamp: 'NickAger 7/18/2011 16:35'!
parseHtmlToPierWikiSyntaxJs
	^ 'var parseHtmlToPierWikiSyntax = function (startNode, baseUrl) {
	var wikiOutput = [];
	var newLine = "\n"
	var surroundingMarkupArray = [];
	var markupEscapes = [];
	var escapeText = true;
	
	var surroundingMarkup = function(markup) {
		if (surroundingMarkupArray.indexOf(markup) == -1) {
			surroundingMarkupArray.push(markup);
		}
		
		return function(node) {
			if (recurseChildNodesToEnsureOnlyInlineElements(node.firstChild)) {
				wikiOutput.push(markup);
				walkTheDOM (node.firstChild);
				wikiOutput.push(markup);
			} else {
				walkTheDOM (node.firstChild);
			}
		}
	}
	
	var startLineMarkup = function(markup) {
		return function(node) {
			// if not at the start of the document
			if (wikiOutput.length) {
				wikiOutput.push(newLine);
			}
			if (markup.length) {
				wikiOutput.push(markup);
			}
			walkTheDOM (node.firstChild);
			wikiOutput.push(newLine);
		}
	}
	
	var paragraphMarkup = function() {
		return function(node) {
			// if not at the start of the document
			if (wikiOutput.length) {
				wikiOutput.push(newLine);
			}
			if (node.className && node.className.indexOf("annotated") !!= -1) {
				wikiOutput.push("@@");
				wikiOutput.push(node.className.substring(10, node.className.length));
				wikiOutput.push(" ");
			}
			walkTheDOM (node.firstChild);
			wikiOutput.push(newLine);
		}
	}
	
	var listWalk = function () {
		return function (node) {
			var startLength = wikiOutput.length;
			walkTheDOM (node.firstChild);
			var endLength = wikiOutput.length;
			
			// remove consecutive new lines. 
			var previousNewLineIndex = -1;
			for (var i = startLength - 1; i < endLength; ++i) {
				if (wikiOutput [i] == newLine) {
					// we have consecutive new lines.
					if (previousNewLineIndex == i - 1) {
						delete wikiOutput [i];
					}
				previousNewLineIndex = i;		
				}
			}
			
			// ensure we finish with a new line
			if (wikiOutput [wikiOutput.length - 1] && wikiOutput [wikiOutput.length - 1] !!= newLine) {
				wikiOutput.push(newLine);
			}
			
			// ensure there is only a single space between the list markup and the list contents
			for (var i = startLength - 1; i < endLength; ++i) {
				if ((wikiOutput [i] == "# " || wikiOutput [i] == "- " || wikiOutput [i] == ": " || wikiOutput [i] == "; ") && (i + 1 < wikiOutput.length)) {
					var listElement = wikiOutput [i + 1];
					var firstNonSpaceIndex = 0;
					while (firstNonSpaceIndex < listElement.length && listElement [firstNonSpaceIndex] == " ") {
						++ firstNonSpaceIndex  ;
					}
					wikiOutput [i + 1] = listElement.substring (firstNonSpaceIndex, listElement.length);
				}
			}		
		}
	}
	
	var listElement = function () {
		return function (node) {
			var parentNode = node;
			while ((parentNode = parentNode.parentNode) 
				&& parentNode.nodeName.toLowerCase() !!= "ul" && parentNode.nodeName.toLowerCase() !!= "ol") {}
			var parentNodeName = "";
			if (parentNode) {
				parentNodeName = parentNode.nodeName.toLowerCase();			
			}
			if (parentNodeName == ''ul'') {
				startLineMarkup(''- '')(node)
			}
			if (parentNodeName == ''ol'') {
				startLineMarkup(''# '')(node)
			}
		}
	}
	
	var preMarkup = function () {
		return function (node) {
			var isCode = false;
			if (node.className && node.className.indexOf("shout") !!= -1) {
				isCode = true;
				escapeText = false;
			}
			var markup = isCode ? "==" : "=";
			
			wikiOutput.push(markup);
			var startLength = wikiOutput.length;
			walkTheDOM (node.firstChild);
			var endLength = wikiOutput.length;
			// replace all new lines in text new-line and start of pre-markup
			for (var i = startLength; i < endLength; ++i) {
				wikiOutput [i] = wikiOutput [i].replace(new RegExp(newLine, "g"), newLine+markup);
			}
			wikiOutput.push(newLine);	
				
			if (isCode) {
				escapeText = true;
			}	
		}
	}
	
	var tableMarkup = function () {
		return function () {}
	}
	
	var anchor = function(node) {
		return function(node) {
			if(node.getAttribute("href")) {
				var hostUrl = window.location.host;
				var anchorUrl = decodeURIComponent(node.getAttribute("href"));
				anchorUrl = anchorUrl.split("?")[0];
				var url = (anchorUrl.indexOf(hostUrl) == 0) ? anchorUrl.substr(hostUrl.length) : anchorUrl;
				if (url.indexOf(baseUrl) == 0) {
					url = url.substr(baseUrl.length);
					if (url.length == 0) {
						url = "\/";
					}
				}
				
				if (url.indexOf("mailto:") == 0) {
					url = url.substr("mailto:".length); 
				}

				wikiOutput.push("*");
				var startLength = wikiOutput.length;
				walkTheDOM(node.firstChild);
				wikiOutput.push(">");
				wikiOutput.push(url);
				wikiOutput.push("*");
				
				// if the url is the same as the caption, we dont need the caption
				if (wikiOutput.length == startLength + 4 && wikiOutput [startLength] == url) {
					delete wikiOutput [startLength];
					delete wikiOutput [startLength + 1];
				}
			}
			if (node.getAttribute("name")) {
				wikiOutput.push("@");
				wikiOutput.push(node.getAttribute("name"));
			}
		}
	}
	
	var spanMarkup = function() {
		return function(node) {
			if (node.className && node.className.indexOf("pierNonEditable") !!= -1) {
				escapeText = false;
				walkTheDOM (node.firstChild);
				escapeText = true;
			}
			else {
				walkTheDOM (node.firstChild);
			}
		}
	}

	var lineBreak = function() {
		return function(node) {
			wikiOutput.push(newLine);
		}
	}
	
	var handleText = function(node) {
		var escapeMarkup = function(text) {
			var initialiseMarkupEscapes = function () {
				var escapedMarkup = function (original) {
					var theEscapedMarkup = [];
					for (var i = 0; i < original.length; ++i) {
						theEscapedMarkup.push("\\");
						theEscapedMarkup.push(original[i]);
					}
					return theEscapedMarkup.join("");
				}
		
				for (var i = 0; i < surroundingMarkupArray.length; ++i) {
					markupEscapes.push({markup: surroundingMarkupArray[i], replacement: escapedMarkup (surroundingMarkupArray[i])})
				}	
				markupEscapes.push({markup: "*", replacement: "\\*"});
				markupEscapes.push({markup: "+", replacement: "\\+"});
			}
	
			if (markupEscapes.length == 0) {
				initialiseMarkupEscapes();
			}
			
			for (var i = 0; i < markupEscapes.length; ++i) {
				text = text.split(markupEscapes[i].markup).join(markupEscapes[i].replacement);		
			}
			return text;
		}	
	
		var text = node.nodeValue;

		// if the string starts with a newLine strip it.
		if (text.length && text [0] == newLine) {
			text = text.substr(1, text.length - 1); 
		}		
		
		// if the string ends with a newLine strip it.
		if (text.length && text [text.length - 1] == newLine) {
			text = text.substr(0, text.length - 1); 
		}
		
		if (escapeText) {
			text = escapeMarkup(text);
		}
		
		wikiOutput.push(text);
	}
	
	var elementToWikiMarkupMappingTable = {
		''b'': surroundingMarkup(''\"\"''),
		''strong'': surroundingMarkup(''\"\"''),
		''i'': surroundingMarkup("\''\''"),
		''em'': surroundingMarkup("\''\''"),
		''ins'': surroundingMarkup("__"),
		''u'': surroundingMarkup("__"),
		"del": surroundingMarkup("--"),
		''code'': surroundingMarkup("=="),
		''sub'': surroundingMarkup("@@"),
		''sup'': surroundingMarkup("^^"),
		"span": spanMarkup(),
		"div": startLineMarkup(''''),
		''a'': anchor(),
		''h1'': startLineMarkup (''!!''),
		''h2'': startLineMarkup(''!!!!''), 
		''h3'': startLineMarkup(''!!!!!!''),
		''h4'': startLineMarkup(''!!!!!!!!''), 
		''h5'': startLineMarkup(''!!!!!!!!!!''), 
		''h6'': startLineMarkup(''!!!!!!!!!!!!''),
		''hr'': startLineMarkup(''_''),
		"br": lineBreak(),
		"p": paragraphMarkup(),
		"ul": listWalk(),
		"ol": listWalk(),	
		"dl": listWalk(),	
		''li'': listElement(),	
		''dt'': startLineMarkup('';''),
		''dd'': startLineMarkup('':''),
		''pre'': preMarkup(),
		''table'': tableMarkup()
	}

	// ensure we dont have lists inside other surrounding elements - Safari editing seems to cause this problem	
	var recurseChildNodesToEnsureOnlyInlineElements = function (node) {	
		if (node === null)
			return true;	

            if  (node.nodeType == nodeTypes.ELEMENT_NODE) {
			var nodeName = node.nodeName.toLowerCase();
			if (elementToWikiMarkupMappingTable.hasOwnProperty (nodeName)) {
				var functionToCall = elementToWikiMarkupMappingTable [nodeName];
				// arbitarily choose "b" as a surrounding element; but in fact we are checking that 
				// node is not any surrounding element markup
				if (functionToCall !!= elementToWikiMarkupMappingTable["b"] && functionToCall !!= anchor()) {
					return false;
				}
				else {
					if (!! recurseChildNodesToEnsureOnlyInlineElements(node.firstChild)) {
						return false;
					}
				}
			}
		}
		return recurseChildNodesToEnsureOnlyInlineElements (node.nextSibling);
	}


    var nodeTypes = {
        ELEMENT_NODE: 1,
        ATTRIBUTE_NODE: 2,
        TEXT_NODE: 3,
        CDATA_SECTION_NODE: 4,
        ENTITY_REFERENCE_NODE: 5,
        ENTITY_NODE: 6,
        PROCESSING_INSTRUCTION_NODE: 7,
        COMMENT_NODE: 8,
        DOCUMENT_NODE: 9,
        DOCUMENT_TYPE_NODE: 10,
        DOCUMENT_FRAGMENT_NODE: 11,
        NOTATION_NODE: 12
    }
	
	// the recursive DOM walker
    var walkTheDOM = function (node) {
		if (node === null)
			return ;
			
		switch (node.nodeType) {
            case nodeTypes.ELEMENT_NODE:
			var nodeName = node.nodeName.toLowerCase();
			if (elementToWikiMarkupMappingTable.hasOwnProperty (nodeName)) {
				elementToWikiMarkupMappingTable [nodeName](node);
			}
			break;
                
            case nodeTypes.TEXT_NODE:
			handleText(node);
			break; 
                
            case nodeTypes.ATTRIBUTE_NODE:
            case nodeTypes.CDATA_SECTION_NODE:
            case nodeTypes.ENTITY_REFERENCE_NODE:
            case nodeTypes.ENTITY_NODE:
            case nodeTypes.PROCESSING_INSTRUCTION_NODE:
            case nodeTypes.COMMENT_NODE:
            case nodeTypes.DOCUMENT_NODE:
            case nodeTypes.DOCUMENT_TYPE_NODE:
            case nodeTypes.DOCUMENT_FRAGMENT_NODE:
            case nodeTypes.NOTATION_NODE:
                break;
			}

		walkTheDOM (node.nextSibling);
    }
    walkTheDOM (startNode.firstChild);
	
	return wikiOutput.join('''');
}'! !

!PRCase class methodsFor: '*pier-wysiwyg' stamp: 'NickAger 7/14/2011 10:39'!
descriptionDocumentWysiwig: aDescription
       ^ aDescription componentClass: PRWysiwygEditorComponent! !

WAComponent subclass: #PRWysiwygEditor
	instanceVariableNames: 'tabs formSubmissionCallback siteMapSelectCallback tabId configuration wikiText textId previewId structureOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygEditor commentStamp: 'NickAger 7/18/2011 16:58' prior: 0!
Base for Wywsiwyg editors using Pier's PRDocument syntax. 
See PRWysiwygEditorExample & PRWysiwygComponent as examples which use this class.!

!PRWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 15:19'!
configuration
	^ configuration ifNil: [ configuration := PRWysiwygEditorConfiguration new ]! !

!PRWysiwygEditor methodsFor: 'private' stamp: 'NickAger 7/15/2011 15:27'!
document
	| document |
	
	document := PRDocumentParser parse: self wikiText.
	self structureOwner notNil ifTrue: [ document owner: self structureOwner ].
	
	^ document ! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/18/2011 16:35'!
editorJs 
	"see: 
		* http://developer.yahoo.com/yui/editor/
		* http://developer.yahoo.com/yui/examples/editor/toolbar_editor.html
		* http://developer.yahoo.com/yui/docs/editor.js.html

		* http://developer.yahoo.com/yui/examples/editor/cal_editor.html
		* http://developer.yahoo.com/yui/examples/editor/flickr_editor.html"
	 
^ 'var pierWysiwygEditor = new YAHOO.widget.Editor("', self textId, '", {
	height: "300px",
	width: "', self editorWidth, '",
	autoHeight: true,
	allowNoEdit: true,
	extracss: ".pierNonEditable { border: 1px dashed; display:inline-block;} ', self configuration editorCss, '",
	toolbar: {
		focusAtStart: true,
		buttons: [ 
	    		{ group: "parastyle", label: "",
				buttons: [
					{ type: "select", label: "Normal", value: "heading", disabled: true,
						menu: [
							{ text: "Normal", value: "none", checked: true },
							{ text: "Header 1", value: "h1" },
							{ text: "Header 2", value: "h2" },
							{ text: "Header 3", value: "h3" },
							{ text: "Header 4", value: "h4" },
							{ text: "Header 5", value: "h5" },
							{ text: "Header 6", value: "h6" }
						]
					}
				]
			},
			{ type: "separator" },
			{ group: "indentlist", label: "",
			    buttons: [
			        { type: "push", label: "Create an Unordered List", value: "insertunorderedlist" },
			        { type: "push", label: "Create an Ordered List", value: "insertorderedlist" }
			    ]
			},
			{ type: "separator" },
			{ group: "textstyle" , label: "",
				buttons: [
            			{ type: "push", label: "Bold CTRL + SHIFT + B",  value: "bold" }, 
					{ type: "push", label: "Italic CTRL + SHIFT + I", value: "italic" }, 
					{ type: "push", label: "Underline CTRL + SHIFT + U", value: "underline" },
					{ type: "push", label: "Code", value: "code" },
					{ type: "push", label: "Strikeout", value: "strike" },
					{ type: "separator" },
					{ type: "push", label: "Subscript", value: "subscript", disabled: true },
					{ type: "push", label: "Superscript", value: "superscript", disabled: true },
				 ]
			 },
	    		{ type: "separator" },
			{ group: "insertitem", label: "",
			    buttons: [
				{ type: "push", label: "Horizontal Rule", value: "rule" },
			        { type: "push", label: "HTML Link CTRL + SHIFT + L", value: "createlink", disabled: true },
			        { type: "push", label: "Insert Image", value: "insertimage" }
			    ]
			}
		]
	}
} );

pierWysiwygEditor._renderCreateLinkWindow = function() {
var Dom = YAHOO.util.Dom,
    Event = YAHOO.util.Event,
    Lang = YAHOO.lang;

	var str = "<label for=''" + this.get("id") + "_createlink_url''><strong>" + this.STR_LINK_URL + ":</strong> <input type=''text'' name=''" + this.get("id") + "_createlink_url'' id=''" + this.get("id") + "_createlink_url'' value=''''></label>";
	str += "<label for=''" + this.get("id") + "_createlink_sitemap''><strong>Sitemap:</strong>', (self siteMapSelectCallback value: self textId), '</label>";
	str += "<label for=''" + this.get("id") + "_createlink_target''><strong>&nbsp;</strong><input type=''checkbox'' name=''" + this.get("id") + "_createlink_target'' id=''" + this.get("id") + "_createlink_target'' value=''_blank'' class=''createlink_target''> " + this.STR_LINK_NEW_WINDOW + "</label>";
	str += "<label for=''" + this.get("id") + "_createlink_title''><strong>" + this.STR_LINK_TITLE + ":</strong> <input type=''text'' name=''" + this.get("id") + "_createlink_title'' id=''" + this.get("id") + "_createlink_title'' value=''''></label>";

	var body = document.createElement("div");
	body.innerHTML = str;

	var unlinkCont = document.createElement("div");
	unlinkCont.className = "removeLink";
	var unlink = document.createElement("a");
	unlink.href = "#";
	unlink.innerHTML = this.STR_LINK_PROP_REMOVE;
	unlink.title = this.STR_LINK_PROP_REMOVE;
	Event.on(unlink, "click", function(ev) {
		Event.stopEvent(ev);
		this.unsubscribeAll("afterExecCommand");
		this.execCommand("unlink");
		this.closeWindow();
	}, this, true);
	unlinkCont.appendChild(unlink);
	body.appendChild(unlinkCont);

	this._windows.createlink = {};
	this._windows.createlink.body = body;
	//body.style.display = "none";
	Event.on(body, "keyup", function(e) {
		Event.stopPropagation(e);
	});
	this.get("panel").editor_form.appendChild(body);
	this.fireEvent("windowCreateLinkRender", { type: "windowCreateLinkRender", panel: this.get("panel"), body: body });
	return body;
}


pierWysiwygEditor._handleCreateLinkClick = function () {
var Dom = YAHOO.util.Dom,
    Event = YAHOO.util.Event,
    Lang = YAHOO.lang;
            var el = this._getSelectedElement();
            if (this._isElement(el, "img")) {
                this.STOP_EXEC_COMMAND = true;
                this.currentElement[0] = el;
                this.toolbar.fireEvent("insertimageClick", { type: "insertimageClick", target: this.toolbar });
                this.fireEvent("afterExecCommand", { type: "afterExecCommand", target: this });
                return false;
            }
            if (this.get("limitCommands")) {
                if (!!this.toolbar.getButtonByValue("createlink")) {
                    return false;
                }
            }
            
            this.on("afterExecCommand", function() {
                var win = new YAHOO.widget.EditorWindow("createlink", {
                    width: "350px"
                });
                
                var el = this.currentElement[0],
                    url = "",
                    title = "",
                    target = "",
                    localFile = false;
                if (el) {
                    win.el = el;
                    if (el.getAttribute("href", 2) !!== null) {
                        url = el.getAttribute("href", 2);
                        if (this._isLocalFile(url)) {
                            //Local File throw Warning
                            win.setFooter(this.STR_LOCAL_FILE_WARNING);
                            localFile = true;
                        } else {
                            win.setFooter(" ");
                        }
                    }
                    if (el.getAttribute("title") !!== null) {
                        title = el.getAttribute("title");
                    }
                    if (el.getAttribute("target") !!== null) {
                        target = el.getAttribute("target");
                    }
                }
                var body = null;
                if (this._windows.createlink && this._windows.createlink.body) {
                    body = this._windows.createlink.body;
                } else {
                    body = this._renderCreateLinkWindow();
                }

                win.setHeader(this.STR_LINK_PROP_TITLE);
                win.setBody(body);

		    Event.purgeElement(this.get("id") + "_createlink_url");

                Dom.get(this.get("id") + "_createlink_url").value = url;
                Dom.get(this.get("id") + "_createlink_title").value = title;
                Dom.get(this.get("id") + "_createlink_target").checked = ((target) ? true : false);
                

                Event.onAvailable(this.get("id") + "_createlink_url", function() {
                    var id = this.get("id");
                    window.setTimeout(function() {
                        try {
                            YAHOO.util.Dom.get(id + "_createlink_url").focus();
                        } catch (e) {}
                    }, 50);

                    if (this._isLocalFile(url)) {
                        //Local File throw Warning
                        Dom.addClass(this.get("id") + "_createlink_url", "warning");
                        this.get("panel").setFooter(this.STR_LOCAL_FILE_WARNING);
                    } else {
                        Dom.removeClass(this.get("id") + "_createlink_url", "warning");
                        this.get("panel").setFooter(" ");
                    }
                    Event.on(this.get("id") + "_createlink_url", "blur", function() {
                        var url = Dom.get(this.get("id") + "_createlink_url");
                        if (this._isLocalFile(url.value)) {
                            //Local File throw Warning
                            Dom.addClass(url, "warning");
                            this.get("panel").setFooter(this.STR_LOCAL_FILE_WARNING);
                        } else {
                            Dom.removeClass(url, "warning");
                            this.get("panel").setFooter(" ");
                        }
                    }, this, true);
                }, this, true);
                
                this.openWindow(win);

            });
        }


pierWysiwygEditor.cmd_code = function (o) {
	this.execCommand("inserthtml", "<code>" + this._getSelection() + "</code>");
}
pierWysiwygEditor.cmd_rule = function (o) {
	this.execCommand("inserthtml", "<hr>");
}
pierWysiwygEditor.cmd_strike = function (o) {
	this.execCommand("inserthtml", "<del>" + this._getSelection() + "</del>");
}

pierWysiwygEditor.render();
'

"	
{ group: ''formatting'' , label: ''Formatting'',
  buttons: [
	{ type: ''separator'' },
	{ type: ''push'', label: ''Remove Formatting'', value: ''removeformat'', disabled: true },
	{ type: ''push'', label: ''Show/Hide Hidden Elements'', value: ''hiddenelements'' }
   ]
}
"
! !

!PRWysiwygEditor methodsFor: 'constants' stamp: 'NickAger 7/14/2011 15:47'!
editorWidth
	^ '550px'! !

!PRWysiwygEditor methodsFor: 'callbacks' stamp: 'NickAger 7/13/2011 16:42'!
formSubmissionCallback
	^ formSubmissionCallback! !

!PRWysiwygEditor methodsFor: 'callbacks' stamp: 'NickAger 7/13/2011 16:42'!
formSubmissionCallback: anObject
	formSubmissionCallback := anObject! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/15/2011 18:03'!
jQueryTabsCustomisationUpdateRoot: anHtmlRoot
		anHtmlRoot stylesheet add:  '
.ui-widget {
	font-size: 11px;
}

.ui-tabs .ui-tabs-hide {
    position: absolute;
    left: -10000px;
}

.ui-tabs .ui-tabs-panel {
	padding: 0px;
	padding-top: 0.5em;
}

.ui-tabs-nav a:hover, .yui-toolbar-container a:hover {
	background:transparent;
}

.ui-widget-header {
	border-color: gray;
	background: white;
}

.ui-state-hover a, .ui-state-hover a:hover {
	color: gray;
}

.ui-state-default, .ui-widget-header .ui-state-default {
	color: white;
}

'! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/17/2011 22:04'!
onSelectTabJSOn: html
	| baseUrl |
	"set element ids for later retrieval"
	self previewId: html nextId.
	self textId: html nextId.
	
	baseUrl := html context actionBaseUrl withoutQuery.
	
	^ ((JSStream on: 
'if (ui.index == 0) {
	pierWysiwygEditor.setEditorHTML("<h1>loading...</h1>")'),
	(html jQuery ajax script: [ :s | 
		s << self renderSetEditorHtmlContentJS]; serialize: (html jQuery id: #wikiEditor)),
	(JSStream on: '}	
if (ui.index == 1) {
	pierWysiwygEditor.setEditorHTML(pierWysiwygEditor.cleanHTML())'),
	((html jQuery id: #wikiEditor) value: (JSStream on: 'parseHtmlToPierWikiSyntax(pierWysiwygEditor._getDoc().body, "', baseUrl greaseString, '")')),
	(JSStream on: '}
if (ui.index == 2) {
	if ($("#', tabId, '").tabs("option", "selected") == 0) {
		$("#wikiEditor").val(parseHtmlToPierWikiSyntax(pierWysiwygEditor._getDoc().body,"', baseUrl greaseString, '"))}
	$("#', self textId, '").val($("#wikiEditor").val());'),
	(html jQuery ajax script: [ :s |
		s << (s jQuery id: self previewId) replaceWith: [ :r | self renderPreviewOn: r ] ]; serialize: (html jQuery id: #wikiEditor)),
	(JSStream on:
'}')) asFunction: #('event' 'ui')! !

!PRWysiwygEditor methodsFor: 'accessing ids' stamp: 'NickAger 7/14/2011 09:06'!
previewId
	^ previewId! !

!PRWysiwygEditor methodsFor: 'accessing ids' stamp: 'NickAger 7/14/2011 09:06'!
previewId: anObject
	^ previewId := anObject! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/17/2011 17:48'!
renderContentOn: html
	(self configuration allowWikiTextEditing and: [ self configuration allowWikiTextEditing ]) 
		ifTrue: [ self renderTabsOn: html ]
		ifFalse: [
			self configuration allowWikiTextEditing ifTrue: [ self renderWikiEditorOn: html ].
			self configuration allowWysiwygEditing ifTrue: [ self renderWysiwygEditorOn: html ] ].
		
	self renderKeepSessionAliveTimerOn: html! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/17/2011 18:04'!
renderKeepSessionAliveTimerOn: html
	 html document addLoadScript: (html jQuery ajax
               callback: [ "Do nothing" ];
               interval: (self application cache expiryPolicy configuration at: #cacheTimeout) * 1000).
! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/15/2011 08:30'!
renderPreviewOn: html
	html div
		id: self previewId;
		style: 'width: ', self editorWidth;
		with: [	
			| renderer |
			renderer := PRViewRenderer new.
			renderer withinContentDo: [ renderer start: self document in: self on: html ] ]! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/17/2011 22:03'!
renderSetEditorHtmlContentJS
	| renderer wysiwygHtml jsStream |
		
	renderer := PRWysiwygHtmlRenderer new.
	wysiwygHtml := WAHtmlCanvas builder
		fullDocument: false;			
		render: [ :r | renderer withinContentDo: [ renderer start: self document in: self on: r ] ].

	jsStream := JSStream new.
	jsStream nextPutAll: 'pierWysiwygEditor.setEditorHTML('.
	JSStream encodeString: wysiwygHtml on: jsStream stream.
	jsStream nextPutAll: ')'.
		
	^ jsStream! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/13/2011 19:16'!
renderTabsOn: html
	html div
		id: (tabId := html nextId);
		script: (html jQuery this tabs
			onSelect: (self onSelectTabJSOn: html));
		with: [
			html unorderedList: [
				self tabs do: [ :each | | id |
					id := html nextId.
					(each value) at: #id put: id.
					html listItem: [
						html anchor
							url: '#', id;
							with: each key ] ] ].
			self tabs do: [ :each | 
				html div
					id: ((each value) at: #id);
					with: [ ((each value) at: #renderer) value: html ] ] ]
! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/13/2011 16:32'!
renderWikiEditorOn: html
	"the standard pier editor toolbar expects the textarea to be wrapped in a td - yuk"
	html table
		cellpadding: 0;
		cellspacing: 0;
		with: [
			html tableRow: [
				html tableData
					class: 'wiki';
					with: [
						html textArea
							id: #wikiEditor;
							on: #wikiText of: self ] ] ]! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/18/2011 11:07'!
renderWysiwygEditorOn: html
	| jsStream setThe baseUrl |

	html textArea
		id: self textId;
		callback: [ :value | self wikiText: value ];
		with: [ html heading level1; with: 'loading...' ].
		
	html script: self editorJs.
	"note we could set the html directly in the text area above (instead of 'loading...') - however subsequently we use 
	pierWysiwygEditor.setEditorHTML('xxxxxx') generated by #setEditorHtmlContentJS and the editor interprets
	 the html subtly differently depending on it's origin - this was a particular problem with the rendering of the 
	verbatim output. 
	So instead we choose to set the editor's html using the same method on the initial and subsequent calls.
	
	We can't call pierWysiwygEditor.setEditorHTML('html here') directly - we have to wait for the editor to 
	load first so we hook into the 'editorContentLoaded' event "
	html script: 
		(JSStream on:  'pierWysiwygEditor.on("editorContentLoaded", function () {') , 
		(self renderSetEditorHtmlContentJS) , 
		(JSStream on: 'this.removeListener("editorContentLoaded", arguments.callee)}, null, null);').
		
	"ensure that we convert the html in the editor into wiki text and copy back into the text 
	area before the form is submitted.
	if both editors are rendered, we ensure that we receives updates from the visible view"
	baseUrl := html context actionBaseUrl withoutQuery.
	self configuration allowWikiTextEditing 
		ifTrue: [
			html script: ('
			$($("form").submit(function(){
			if ($("#', tabId, '").tabs("option", "selected") == 0) {
				$("#wikiEditor").val(parseHtmlToPierWikiSyntax(pierWysiwygEditor._getDoc().body, "', baseUrl greaseString, '"))}
			$("#', textId, '").val($("#wikiEditor").val())}))') ]
		ifFalse: [ 
			html script: '$($("form").submit(function(){$("#', textId, '").val(parseHtmlToPierWikiSyntax(pierWysiwygEditor._getDoc().body, "', baseUrl greaseString, '"))}))'].! !

!PRWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/17/2011 18:23'!
setEditorHtmlContentJS
	| renderer wysiwygHtml jsStream |
		
	renderer := PRWysiwygHtmlRenderer new.
	wysiwygHtml := WAHtmlCanvas builder
		fullDocument: false;			
		render: [ :r | renderer withinContentDo: [ renderer start: self document in: self on: r ] ].

	jsStream := JSStream new.
	jsStream nextPutAll: 'pierWysiwygEditor.setEditorHTML('.
	JSStream encodeString: wysiwygHtml on: jsStream stream.
	jsStream nextPutAll: ')'.
		
	^ jsStream! !

!PRWysiwygEditor methodsFor: 'callbacks' stamp: 'NickAger 7/13/2011 14:28'!
siteMapSelectCallback
	^ siteMapSelectCallback ifNil: [
		siteMapSelectCallback := [ :id | '<select id=''', id, '_createlink_sitemap''><option>sitemap NOT configured</option></select>'] ]! !

!PRWysiwygEditor methodsFor: 'callbacks' stamp: 'NickAger 7/13/2011 14:28'!
siteMapSelectCallback: anObject
	siteMapSelectCallback := anObject! !

!PRWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/15/2011 15:29'!
structureOwner
	^ structureOwner! !

!PRWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/15/2011 15:25'!
structureOwner: theStructureOwner
	structureOwner := theStructureOwner! !

!PRWysiwygEditor methodsFor: 'private' stamp: 'NickAger 7/14/2011 08:33'!
tabs
	^ tabs ifNil: [
		tabs := OrderedCollection new.
		tabs 
			add: (Association key: 'Wysiwyg editor' value: ((Dictionary new) 
				at: #renderer put: [ :r | self renderWysiwygEditorOn: r ];
				yourself));
			add: (Association key: 'Wiki Editor' value: ((Dictionary new) 
				at: #renderer put: [ :r | self renderWikiEditorOn: r ];
				yourself));
			add: (Association key: 'Preview' value: ((Dictionary new) 
				at: #renderer put: [ :r | self renderPreviewOn: r ];
				yourself));
			yourself ]! !

!PRWysiwygEditor methodsFor: 'accessing ids' stamp: 'NickAger 7/14/2011 09:05'!
textId
	^ textId! !

!PRWysiwygEditor methodsFor: 'accessing ids' stamp: 'NickAger 7/14/2011 09:05'!
textId: anObject
	^ textId := anObject! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/13/2011 18:45'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	self wysiwygEditorUpdateRoot: anHtmlRoot.
	self jQueryTabsCustomisationUpdateRoot: anHtmlRoot.
	self wikiEditorCustomisationUpdateRoot: anHtmlRoot! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/14/2011 15:47'!
wikiEditorCustomisationUpdateRoot: anHtmlRoot
	anHtmlRoot stylesheet add:  '
textarea#wikiEditor {
	width: ', self editorWidth,';
}

td.wiki {
	padding-left:0px;
	padding-right:0px;
}
'! !

!PRWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 16:30'!
wikiText
	^ wikiText ifNil: [ 
		wikiText := '!!A Wysiwyg editor for Pier

Currently the editor supports:
# ""Bold""
# ''''Italic''''
# __Underline__
# ==code==
# --strikeout--
# Headings
# line-breaks and paragraphs
# ordered and unordered lists.
# super^^script^^ and sub@@script@@
# horizontal line

_
The translator also supports the following, although there are no editor buttons to support it:
- definition list and definitions
- preformated.
- named anchors
- email addresses: *mail me>nick.ager@gmail.com*
- annotated paragraphs
@ananchor

@@note an annotated paragraph

=Some preformed text
=more preformed stuff
=whats is going on

A Definition List:
;Wysiwyg
:What you see is what you get
;Editor
:A computer program enabling the user to alter or rearrange online text

Still to come support for tables. Support for internal links still needs to be expanded.

!!!!!! Support verbatim, embedded links and value links
The editor attempts to support all the Pier Wiki markup, so the Wysiwyg editor can be used interchangeably with the standard editor without fear of loosing any markup so, for example, it should be possible to use for editing Pier book content. I''ve taken the approach of preserving verbatim, embedded and value links in the Wysiwyg editor, but not making them editable. The editor could be extended with custom dialogs in which the raw wiki syntax could be edited.

Some non-editable wiki content:
{{{<div class="pierIcon">verbatim test</div>}}}
+value:time+
_

!!!!!! Thoughts and questions
Some features should only be enabled for users with sufficient permissions. For example you don''t want untrusted users to be able to insert verbatium html or edit the content in the wiki standard view. However, is it acceptable to make the Wysiwyg editor dependant on Pier-Security? 
I propose we enable/disable features based on the following permissions:
- ==PRVerbatiumMarkupPermission==
- ==PRWikiTextEditingPermission==
- ==PREmbeddedLinksPermission==
- ==PRValueLinksPermission==

!!!!!!Useful links
- *http://developer.yahoo.com/yui/editor/*
- *http://yuiblog.com/assets/pdf/cheatsheets/editor.pdf*
- *http://developer.yahoo.com/yui/examples/editor/toolbar_editor.html*
- *http://developer.yahoo.com/yui/docs/editor.js.html*
- *http://developer.yahoo.com/yui/examples/editor/cal_editor.html*
- *http://developer.yahoo.com/yui/examples/editor/flickr_editor.html*']! !

!PRWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/18/2011 10:57'!
wikiText: theWikiText
	wikiText := theWikiText.
	(self formSubmissionCallback notNil and: [ self requestContext request isPost ]) ifTrue: [
		"Magritte works out if the submission was saved or cancelled"
		self formSubmissionCallback value: theWikiText ]! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/13/2011 19:00'!
wysiwygEditorCustomisationUpdateRoot: anHtmlRoot
	anHtmlRoot bodyAttributes addClass: 'yui-skin-sam'.
	anHtmlRoot javascript url: PRWysiwygFileLibrary / #parseHtmlToPierWikiSyntaxJs.
	
	anHtmlRoot stylesheet add: '
.yui-toolbar-group {
	margin-top: 4px;
}
.yui-skin-sam .yui-toolbar-container .yui-toolbar-code span.yui-toolbar-icon {
	background-image: url( /files/PREditorScripts/toolbar.png );
	background-position: -64px 0px;
	margin-left: 5px;
	margin-top: 2px;
}

.yui-skin-sam .yui-toolbar-container .yui-toolbar-rule span.yui-toolbar-icon {
	background-image: url( /files/PREditorScripts/toolbar.png );
	background-position: -208px 0px;
	margin-left: 5px;
	margin-top: 2px;
}

.yui-skin-sam .yui-toolbar-container .yui-toolbar-strike span.yui-toolbar-icon {
	background-image: url( /files/PREditorScripts/toolbar.png );
	background-position: -48px 0px;
	margin-left: 5px;
	margin-top: 2px;
}


'
	
! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/8/2011 16:35'!
wysiwygEditorStandardConfigUpdateRoot: anHtmlRoot
	anHtmlRoot stylesheet url: 'http://yui.yahooapis.com/2.9.0/build/assets/skins/sam/skin.css'.
	
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/yahoo-dom-event/yahoo-dom-event.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/element/element-min.js'.
	
	"Needed for Menus, Buttons and Overlays used in the Toolbar"
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/container/container_core-min.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/menu/menu-min.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/button/button-min.js'.
	
	"Source file for Rich Text Editor"
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/editor/editor-min.js'.	

	"non minimised versions"
	"anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/yahoo/yahoo.js'.	
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/dom/dom.js'.	
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/event/event.js'.
		
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/element/element.js'.
	
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/container/container_core.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/menu/menu.js'.
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/button/button.js'.
	
	anHtmlRoot javascript url: 'http://yui.yahooapis.com/2.9.0/build/editor/editor.js'.	"
! !

!PRWysiwygEditor methodsFor: 'updating' stamp: 'NickAger 7/8/2011 05:53'!
wysiwygEditorUpdateRoot: anHtmlRoot.
	"See YUI editor documentation: 
		* http://developer.yahoo.com/yui/editor/
		* http://yuiblog.com/assets/pdf/cheatsheets/editor.pdf"

	self wysiwygEditorStandardConfigUpdateRoot: anHtmlRoot.
	self wysiwygEditorCustomisationUpdateRoot: anHtmlRoot.
! !

PRWysiwygEditor subclass: #PRWysiwygEditorExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygEditorExample class methodsFor: 'initialize-release' stamp: 'NickAger 7/13/2011 13:56'!
initialize
	super initialize.
	self register! !

!PRWysiwygEditorExample class methodsFor: 'initialize-release' stamp: 'NickAger 7/13/2011 13:56'!
register
	(WAAdmin register: self asApplicationAt: 'wysiwygtest')
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQRedmondTheme;
		preferenceAt: #scriptGeneratorClass put: JQScriptGenerator.! !

!PRWysiwygEditorExample methodsFor: 'initialization' stamp: 'NickAger 7/13/2011 22:37'!
initialize
	super initialize.
	self siteMapSelectCallback: [:id | self siteMapSelectId: id ].
	self setExampleText
	! !

!PRWysiwygEditorExample methodsFor: 'rendering' stamp: 'NickAger 7/13/2011 13:56'!
renderContentOn: html
	html form: [ super renderContentOn: html ]! !

!PRWysiwygEditorExample methodsFor: 'initialization' stamp: 'NickAger 7/14/2011 12:22'!
setExampleText
	self wikiText: '!!A Wysiwyg editor for Pier

Currently the editor supports:
# ""Bold""
# ''''Italic''''
# __Underline__
# ==code==
# --strikeout--
# Headings
# line-breaks and paragraphs
# ordered and unordered lists.
# super^^script^^ and sub@@script@@
# horizontal line

_
The translator also supports the following, although there are no editor buttons to support it:
- definition list and definitions
- preformatted.
- shout code formatting.
- named anchors
- email addresses: *mail me>nick.ager@gmail.com*
- annotated paragraphs
@ananchor

@@note an annotated paragraph

=Some preformed text
=more preformed stuff
=whats is going on

A Definition List:
;Wysiwyg
:What you see is what you get
;Editor
:A computer program enabling the user to alter or rearrange online text

Still to come support for tables. Support for internal links still needs to be expanded.

!!!!!! Support verbatim, embedded links and value links
The editor attempts to support all the Pier Wiki markup, so the Wysiwyg editor can be used interchangeably with the standard editor without fear of loosing any markup so, for example, it should be possible to use for editing Pier book content. I''ve taken the approach of preserving verbatim, embedded and value links in the Wysiwyg editor, but not making them editable. The editor could be extended with custom dialogs in which the raw wiki syntax could be edited.

Some non-editable wiki content:
{{{<div class="pierIcon">verbatim test</div>}}}
+value:date+
_

!!!!!! Thoughts and questions
Some features should only be enabled for users with sufficient permissions. For example you don''t want untrusted users to be able to insert verbatim html or edit the content in the wiki standard view. However, is it acceptable to make the Wysiwyg editor dependent on Pier-Security? 
I propose we enable/disable features based on the following permissions:
- ==PRVerbatiumMarkupPermission==
- ==PRWikiTextEditingPermission==
- ==PREmbeddedLinksPermission==
- ==PRValueLinksPermission==

!!!!!!Useful links
- *http://developer.yahoo.com/yui/editor/*
- *http://yuiblog.com/assets/pdf/cheatsheets/editor.pdf*
- *http://developer.yahoo.com/yui/examples/editor/toolbar_editor.html*
- *http://developer.yahoo.com/yui/docs/editor.js.html*
- *http://developer.yahoo.com/yui/examples/editor/cal_editor.html*
- *http://developer.yahoo.com/yui/examples/editor/flickr_editor.html*'! !

!PRWysiwygEditorExample methodsFor: 'callback-support' stamp: 'NickAger 7/13/2011 14:47'!
siteMapSelectId: textId
	| renderedSelectHtml kernel user viewableStructures structurePaths |
	
	"I want to see how the site map appears to a non-admin user, so add myself to the kernel if I'm not already there"
	kernel := PRKernel instances anyOne.
	user :=  kernel userNamed: 'nick.ager@gmail.com' ifNone: [ kernel users add: ((PUUser named: 'nick.ager@gmail.com') password: 'apassword'; yourself) ].
	viewableStructures := kernel root enumerator with; all; select: [ :aStructure | aStructure securityDecoration hasPermission: (PUPermission on: PRViewCommand) for: user].
	
	structurePaths := viewableStructures collect: [ :aStructure | aStructure absolutePath].
	structurePaths := (Array with:  'OR select a location Url from site-map ...') , structurePaths.
	
	renderedSelectHtml := WAHtmlCanvas builder
		fullDocument: false;			
		render: [:html | 
			html select
				id: textId, '_createlink_sitemap';
				list: structurePaths ].

	renderedSelectHtml replaceAll: $" with: $'.	"subsitute double quotes for single quotes"
		
	^ renderedSelectHtml! !

!PRWysiwygEditorExample methodsFor: 'updating' stamp: 'NickAger 7/13/2011 18:39'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	PREditorScripts default updateRoot: anHtmlRoot.
! !

PRDocumentComponent subclass: #PRWysiwygEditorComponent
	instanceVariableNames: 'editor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygEditorComponent methodsFor: 'hooks' stamp: 'NickAger 7/13/2011 13:49'!
children
	^ Array with: self editor! !

!PRWysiwygEditorComponent methodsFor: 'accessing' stamp: 'NickAger 7/18/2011 16:56'!
editor
	^ editor ifNil: [
		editor := (PRWysiwygEditor new)
			siteMapSelectCallback: [ :id | self siteMapSelectId: id ];
			formSubmissionCallback: [ :value | self string: value ];
			structureOwner: self context structure;
			yourself ]! !

!PRWysiwygEditorComponent methodsFor: 'rendering' stamp: 'NickAger 7/13/2011 16:31'!
renderEditorOn: html
	self editor wikiText: self string.
	html render: self editor! !

!PRWysiwygEditorComponent methodsFor: 'private' stamp: 'NickAger 7/13/2011 14:47'!
siteMapSelectId: textId
	| theContext user viewableStructures structurePaths renderedSelectHtml |

	theContext := self context.
	user :=  theContext user.
	viewableStructures := theContext kernel root enumerator with; all; select: [ :aStructure | aStructure securityDecoration hasPermission: (PUPermission on: PRViewCommand) for: user].
	
	structurePaths := viewableStructures collect: [ :aStructure | aStructure absolutePath].
	structurePaths := (Array with:  'OR select a location Url from site-map ...') , structurePaths.
	
	renderedSelectHtml := WAHtmlCanvas builder
		fullDocument: false;			
		render: [:html | 
			html select
				id: textId, '_createlink_sitemap';
				list: structurePaths ].

	renderedSelectHtml replaceAll: $" with: $'.	"subsitute double quotes for single quotes"
		
	^ renderedSelectHtml! !

!PRWysiwygEditorComponent methodsFor: 'updating' stamp: 'NickAger 7/13/2011 13:52'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	JQDeploymentLibrary default updateRoot: anHtmlRoot.
	JQUiDeploymentLibrary default updateRoot: anHtmlRoot.
	JQRedmondTheme default updateRoot: anHtmlRoot! !

PUPermission subclass: #PRWikiTextEditingPermission
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

Object subclass: #PRWysiwygEditorConfiguration
	instanceVariableNames: 'allowWikiTextEditing allowWysiwygEditing allowVerbatumMarkup allowEmbeddedLinks allowValueLinks editorCss'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Wysiwyg'!

!PRWysiwygEditorConfiguration methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 15:16'!
allowEmbeddedLinks
	^ allowEmbeddedLinks! !

!PRWysiwygEditorConfiguration methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 15:16'!
allowEmbeddedLinks: anObject
	allowEmbeddedLinks := anObject! !

!PRWysiwygEditorConfiguration methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 15:16'!
allowValueLinks
	^ allowValueLinks! !

!PRWysiwygEditorConfiguration methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 15:16'!
allowValueLinks: anObject
	allowValueLinks := anObject! !

!PRWysiwygEditorConfiguration methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 15:16'!
allowVerbatumMarkup
	^ allowVerbatumMarkup! !

!PRWysiwygEditorConfiguration methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 15:16'!
allowVerbatumMarkup: anObject
	allowVerbatumMarkup := anObject! !

!PRWysiwygEditorConfiguration methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 15:17'!
allowWikiTextEditing
	^ allowWikiTextEditing ifNil: [ allowWikiTextEditing := true ]! !

!PRWysiwygEditorConfiguration methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 15:16'!
allowWikiTextEditing: anObject
	allowWikiTextEditing := anObject! !

!PRWysiwygEditorConfiguration methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 15:18'!
allowWysiwygEditing
	^ allowWysiwygEditing ifNil: [ allowWysiwygEditing := true ]! !

!PRWysiwygEditorConfiguration methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 15:16'!
allowWysiwygEditing: anObject
	allowWysiwygEditing := anObject! !

!PRWysiwygEditorConfiguration methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 22:01'!
editorCss
	^ editorCss ifNil: [editorCss := 'p.important, p.todo, p.note, p.advanced, pre {padding:0.8em; margin-bottom: 1em; border-radius:5px; background:#ebebeb;} .p.important {background:#e8e0ef;} p.todo {color:red} p.note {color: blue} pre {background: #eee}']! !

!PRWysiwygEditorConfiguration methodsFor: 'accessing' stamp: 'NickAger 7/13/2011 20:00'!
editorCss: anObject
	editorCss := anObject! !
PRWysiwygEditorExample initialize!
